Use Case 1: Wypłata gotówki
=====================

**Aktor podstawowy:**  Klient 


Główni odbiorcy i oczekiwania względem systemu:
-----------------------------------------------

 - Klient: oczekuje możliwośći wypłaty gotówki o dowolnej porze dnia.
 - Klient: oczekuje możliwości uzyskania potwierdzenia dokonanej operacji.
 - Bank: przeprowadzana transakcja jest bezproblemowa dla obu stron. 
 
Warunki wstępne:
----------------

 - Klient posiada aktywne konto w banku oraz jest w posiadaniu sprawnej karty bankomatowej do tego konta.
 - Bankomat ma aktywne połączenie z bankiem oraz jest w pełni sprawny tj. sprawny ekran, czytnik kart, klawiatura oraz urządzenie do wydawania pieniędzy.

Warunki końcowe:
----------------
 - Wypłata gotówki jest bezpieczna i bezproblemowa dla klienta. Klient otrzymał odebrał swoja kartę z czytnika. Jeśli zostało wydrukowane klient otrzymuje potwierdzenie dokonania transakcji. Wydawana jest wybrana ilośc gotówki. 

Scenariusz główny (ścieżka podstawowa):
---------------------------------------

 1.Klient wkłada kartę do czytnika kart w bankomacie.  
 2.Bankomat wyświetla prośbę o wprowadzane numeru PIN.  
 3.Klient wprowadza PIN.  
 4.Bankomat weryfikuje PIN na podstawie konta użytkownika powiązanego z kartą.  
 5.Bankomat wyświetla możliwe do przeprowadzenia operacje.  
 6.Klient wybiera opcję wypłaty.  
 7.Bankomat wyświetla proponowane kwoty wypłaty.  
 8.Klient wybiera kwotę.  
 9.Bankomat pyta o potwierdzenie.  
 10.Klient potwierdza operację i decyduje czy ma ono zostać wydrukowane.  
 11.Bankomat wydaje kartę.  
 12.Klient odbiera kartę z czytnika.  
 13.Bankomat wydaje żądaną ilość pieniędzy.  
 14.Klient odbiera wypłacone pieniądze z bankomatu.  
 15.Saldo klienta zostaje pomniejszone o wypłacona sumę pieniędzy.  
 16.Bankomat drukuje potwierdzenie dokonanej wypłaty gotówki.  

Rozszerzenia (ścieżki alternatywne):
------------------------------------

 *a. Zawieszenie systemu/Błąd systemu.

   1. Bankomat wyświetla informację o wystąpieniu błędu.  
   2. Jeśli klient wprowadził kartę do czytnika, zostaje ona wysunięta z bankomatu.
   3. Klient odbiera kartę z czytnika.  

     3a. Klient nie odebrał karty z czytnika.
          1. Przejście do kroku 12a.  
   4. Bankomat powiadamia serwisanta.  
   5. Bankomat wyświetla informację o niedostępności bankomatu.  
 
1a. Czytnik kart uszkodzony. 

   1. Bankomat wyświetla informację o wystąpieniu błędu czytnika.  
   2. Bankomat wydaje kartę.  
   3. Klient odbiera kartę z czytnika.  

     3a. Klient nie odebrał karty z czytnika.
          1. Przejście do kroku 12a.  
   4. Bankomat powiadamia serwisanta.  
   5. Bankomat wyświetla informację o niedostępności bankomatu.   
 
1b. Czytnik kart nie rozpoznaje wprowadzonej karty.  

   1. Bankomat wyświetla informację o wystąpieniu błędu odczytu karty.  
   2. Bankomat wydaje kartę.  
   3. Klient odbiera kartę z czytnika.  

     3a. Klient nie odebrał karty z czytnika.  
          1. Przejście do kroku 12a.   
   3. Bankomat wyświetla prośbę, aby klient spróbował ponownie.  
   4. Powrót do kroku 1 ze scenariusza głównego.   

 4a. Klient wprowadził nieprawidłowy kod PIN.  

   1. Bankomat wyświetla informację o nieprawidłowym kodzie PIN.  
   2. Bankomat wysyła do banku informację o wprowadzeniu nieprawidłowego kodu PIN.  
   
     2a. Klient wprowadził nieprawidłowy kod PIN trzeci raz z rzędu.  
       1. Bankomat wyświetla informację o wprowadzeniu nieprawidłowego kodu PIN poraz trzeci oraz o zablokowaniu konta.  
       2. Bankomat wydaje kartę.   
       3. Klient odbiera kartę z czytnika.       
          3a. Klient nie odebrał karty z czytnika.  
             1. Przejście do kroku 12a.  
       3. Po upływie 5s bankomat powraca na ekran startowy.  
   3. Powrót do kroku 2 ze scenariusza głównego.   


8a. Klient wybrał kwotę, która przekracza maksymalną wysokość jednorazowej wypłaty ustalonej przez bank. 
   1.  Bankomat wyświetla informację o wybraniu kwoty przekraczającej wysokość jednorazowej wypłaty.  
   2. Bankomat wydaje kartę.  
   3. Klient odbiera kartę z czytnika.  

    3a. Klient nie odebrał karty z czytnika.  
          1. Przejście do kroku 12a. 
   3.  Powrót do kroku 1 ze scenariusza głównego.  

8b. Klient wybrał kwotę, która przekracza dzienny limit wypłat klienta. 
   1. Bankomat wyświetla informację o wybraniu kwoty, która przekrocza dziennego limit wypłat gotówki.
   2. Bankomat wydaje kartę.  
   3. Klient odbiera kartę z czytnika. 
   
    3a. Klient nie odebrał karty z czytnika.  
          1. Przejście do kroku 12a. 
   3.  Powrót do kroku 1 ze scenariusza głównego.     
  
8c. Wybrana kwota przekracza wysokość salda klienta.
   1. Bankomat wyświetla informację o wybraniu kwoty, która przekracza saldo klienta.  
   2. Bankomat wydaje kartę.  
   3. Klient odbiera kartę z czytnika.  
    
    3a. Klient nie odebrał karty z czytnika.  
          1. Przejście do kroku 12a. 
   3.  Powrót do kroku 1 ze scenariusza głównego.     

10a. Klient przez 60 sekund nie potwierdził dokonania operacji.    
   1. Bankomat wyświetla informację o braku potwierdzenia operacji.   
   2. Bankomat wydaje kartę.   
   3. Klient odbiera kartę z czytnika.  

    3a. Klient nie odebrał karty z czytnika.  
          1. Przejście do kroku 12a.   
   4. Powrót do kroku 1 ze scenariusza głównego.   
   
12a. Klient nie odebrał karty.
  1. Bankomat wydaje sygnał dźwiękowy.  
  2. Jeśli klient nadal nie odebrał karty zostaje ona wciągnięta do środka.    
  3. Bankomat wysyła powiadamienie do banku o pozostawionej karcie.  
  4. Bank blokuje kartę.  
  5. Bankomat powraca na ekran startowy.  

14a. Klient przez 60 sekund nie odebrał wypłaconej gotówki z bankomatu.  
  1. Bankomat wydaje sygnał dźwiękowy.  
  2. Jeśli klient nadal nie odebrał wypłaconej gotówki zostaje ona wciągnięta do środka.  
  3. Bankomat powraca na ekran startowy.  
 

Wymagania specjalne:
--------------------

 - Domyślnym językiem wyświetlania jest język Polski.
 - Bankomat umożliwia zmianę języka na jeden z poniższych: 
    1. Angielski.
    2. Niemiecki.
    3. Hiszpański.
    4. Rosyjski.

Wymagania technologiczne oraz ograniczenia na wprowadzane dane:
---------------------------------------------------------------
3a. Kod PIN składa się z 4 cyfr.  
8a. Wybrana kwota jest podzielna bez reszty przez liczbę 10. 

Kwestie otwarte:
----------------
 - Czy obowiązuje minimalna kwota wypłaty gotówki ?
