Use Case 2: Wpłata gotówki
=====================

**Aktor podstawowy:** Klient


Główni odbiorcy i oczekiwania względem systemu:
-----------------------------------------------
 - Klient: chce zrealizować szybko żądaną operację, oczekuje potwierdzenia wykonanej transkacji. 
 - Bank: chce otrzymać potwierdzenie, że w bankomacie została umieszczona odpowiednia ilość gotówki. 

Warunki wstępne:
----------------
Klient musi posiadać konto bankowe oraz wydaną przez bank kartę. Bankomat ma aktywne połączenie z bankiem. W bankomacie poprawnie działa urządzenie do pobierania gotówki i karty, klawiatura, ekran oraz kamera. W bankomacie jest odpowiednia ilość papieru, aby wydrukować potwierdzenie. 

Warunki końcowe:
----------------
Wpłacone środki są prawidłowo przeliczone i dodane do konta klienta. System bankowy jest zaktualizowany. Potwierdzenie wykonanej operacji zostało wydrukowane. Karta została odebrana przez klienta. Transakcja została dodana do historii transakcji klienta.

Scenariusz główny (ścieżka podstawowa):
---------------------------------------

1. Klient wkłada kartę do bakomatu.  
2. System wyświetla prośbę o wprowadzenie numeru PIN.  
3. Klient wprowadza PIN.  
4. System weryfikuje PIN na podstawie konta użytkownika powiązanego z kartą.  
5. System prosi o wybranie opcji operacji.  
6. Klient wybiera opcję wpłaty.  
7. System prosi o włożenie banknotów.  
8. Klient wkłada banknoty.  
9. Bankomat przelicza włożone banknoty.  
10. Bankmoat wyświetla sumę włożonych banknotów.
11. Bankomat pyta o potwierdzenie. 
12. Klient potwierdza operację wpłaty. 
13. Bankomat wydaje kartę.  
14. Klient odbiera kartę.  
15. Bankomat zasila konto powiązane z kartą.  
16. Bankomat drukuje potwierdznie.  

Rozszerzenia (ścieżki alternatywne):
------------------------------------

  *a. Zawieszenie/Błąd systemu.  

    1. Bankomat wyświetla komunikat o błędzie.  
      1a. Stan wykonywanych operacji.  
          1. Jeśli karta została umieszczona zostaje ona oddana.  
          2. Klient odbiera kartę.  
            2a. Klient nie odebrał karty.  
              1. Przejście do kroku 14a.  
          3. Jeśli gotówka została włożona zostaje ona oddana. 
          4. Klient odbiera gotówkę.   
    2. Bankomat powiadamia serwisanta.  
    3. Bankomat wyświetla komunikat o swojej niedostępności.  

  1a. Karta nie została rozpoznana.

    1. Bankomat wyświetla komunikat o nierozpoznaniu karty.  
    2. Bankomat oddaje kartę.  
    3. Klient odbiera kartę.  
      3a. Klient nie odebrał karty.  
        1. Przejście do kroku 14a.  
    4. Bankomat wyświetla komunikat, aby spróbować ponownie włożyć kartę do bankomatu.  
    5. Powró† do kroku 1 ze scenariusza głównego.  

  4a. Klient podał błędny PIN.  

    1. Bankomat wyświetla komunikat o podaniu błędnego PIN-u.  
    2. Bank otrzymuje informację o podaniu błędnego PIN-u.  
      2a. Bank dostał informacje o podaniu złego PIN-u trzeci raz z rzędu.  
        1. Bankomat wyświetla komunikat o podaniu złego PIN-u trzeci raz z rzędu.  
        2. Karta zostaje zablokowana.  
        3. Bankomat pozostawia kartę w swoim wnętrzu. 
        4. Bankomat powraca do ekranu startowego.  
    3. Bankomat oddaje kartę.
    4. Klient odbiera kartę.   
      4a. Klient nie odebrał karty.  
        1. Przejście do kroku 14a.   
    5. Powrót do kroku 1 ze scenariusza głównego.  

  6a. Klient wybrał złą opcję operacji.  

    1. Klient wciska przycisk powrót.  
    2. Powrót do kroku 5 ze scenariusza głównego.  
     
  8a. Klient nie włożył banknotów do bankomatu przez 60s.

    1. Bankomat wyświetla komunikat o braku włożenia banknotów.  
    2. Bankomat oddaje kartę.  
    3. Klient odbiera kartę.  
      3a. Klient nie odebrał karty.  
        1. Przejście do kroku 14a.  
    4. Powrót do kroku 1 ze scenariusza głównego.  
  
  9a. Bankomat nie rozpoznaje banknotów.    
  
    1. Bankomat wyświetla komunikat, że nie rozpoznał banknotów.  
    2. Bankomat oddaje kartę.  
    3. Klient odbiera kartę.  
      3a. Klient nie odebrał karty.  
        1. Przejście do kroku 14a.  
    4. Bankomat oddaje włożoną gotówkę.  
    5. Klient odbiera gotówkę.  
    6. Bankomat powiadamia serwisanta.  
    7. Bankmoat wyłącza opcję wpłaty.
    8. Powrót do kroku 1 ze scenariusza głównego.  

  12a. Klient nie potwierdza operacji wpłaty przez 60s.  

    1. Bankomat wyświetla komunikat o braku potwierdzenia operacji.  
    2. Bankomat oddaje kartę.  
    3. Klient odbiera kartę.  
      3a. Klient nie odebrał karty.  
        1. Przejście do kroku 14a.  
    4. Bankomat oddaje włożoną gotówkę.  
    5. Klient odbiera gotówkę.  
    6. Powrót do kroku 1 ze scenariusza głównego.  
  
  14a. Klient nie odebrał karty.  

    1. Bankomat wydaje sygnał dżwiękowy.  
    2. Jeśli karta nadal jest w bankomacie zostaje ona wsunięta do jego wnętrza.  
    3. Bankomat powiadamia bank o pozostawionej karcie.  
    4. Bank blokuje kartę.  

Wymagania specjalne:
--------------------

  - Możliwość wyboru języka w bankomacie (polski, angielski, niemiecki, rosyjski, hiszpański). 


Wymagania technologiczne oraz ograniczenia na wprowadzane dane:
---------------------------------------------------------------

    2a. Pin składa się z 4 cyfr.  
    8a. Bankomat przyjmuje banknoty 50zł, 100zł, 200zł, 500zł.  

Kwestie otwarte:
----------------

  - Czy dopuszczamy autoryzację z wykorzystaniem rozpoznawania twarzy zamiast podawania numeru PIN?  
