Use Case 4: Doładowanie karty prepaidowej
=====================

**Aktor podstawowy:** Klient


Główni odbiorcy i oczekiwania względem systemu:
-----------------------------------------------

 - Klient: Sprawnie i w przejrzysty sposób zakupić kod prepaid.

 - Bank: Poprawne przprowadzenie tranzakcji możliwie wykluczając błędy, zadowolenie Klienta.


Warunki wstępne:
----------------
Klient musi posiadać konto bankowe wraz z wydaną przez bank kartą. 

Warunki końcowe:
----------------
Klijent otrzymał z powrotem swoją kartę. Paragon z kodem doładowania oraz potwierdzenie zostały wydrukowane.
Obciążono konto klienta odpowiednią kwotą. Odpowiedni kod prepaid został stworzony. 

Scenariusz główny (ścieżka podstawowa):
---------------------------------------

 1. Klient wkłada kartę do bakomatu.
 2. Bankomat prosi o wrowadzenie numeru PIN.
 3. Klient wprowadza PIN.
 4. Bankomat weryfikuje PIN na podstawie konta użytkownika powiązanego z kartą.
 5. Bankomat prosi o wybranie wyświetlonych opcji.
 6. Klient wybiera opcję “zakup kodu prepaid”.
 7. Bankomat prosi o wybranie kwoty.
 8. Klient wybiera kwotę.
 9. Bankomat pyta czy wydrukować potwierdzenie.
 10. Klient zgadza się na wydruk potwierdzenia.
 11. Bankomat wydaje kartę.
 12. Bankomat drukuje paragon z kodem doładowania.
 13. Bankomat drukuje potwierdznie.

Rozszerzenia (ścieżki alternatywne):
------------------------------------

 *a. Zawieszenie systemu/Błąd systemu.
   1. Bankomat wysuwa kartę jeśli takową posiada.
   2. Bankomat resetuje się.
   3. Bankomat wyświetla informację o tymczasowej niedostępności.
   4. Bankomat wysyła komunikat o niepoprwnym działaniu do serwisanta.
 
 1a. Zablokowana karta.
   1. Bankomat wyświetla komunikat o zablokowanej karcie.
   2. Bankomat wysuwa kartę.
   3. Bankomat powraca do ekranu starowego po upływie 5 sekund.

 1b. Karta jest nieaktywna.
   1. Bankomat wyświetla komunikat o nieaktywnej karcie.
   2. Bankomat wysuwa kartę.
   3. Bankomat powraca do ekranu starowego po upływie 5 sekund.

 1c. Nie można odczytać karty.
   1. Bankomat wyświetla komunikat o błędzie podczas odczytu karty.
   2. Bankomat wysuwa kartę.
   3. Bankomat powraca do ekranu starowego po upływie 5 sekund.

 4a. Nieprawidłowy pin.
   1. Bankomat wysyła informację do banku o nieprawidłowym kodzie PIN.
   2. powrót do kroku 4.

     2a. Zablokowanie karty na podstawie informacji wysłanej przez bankomat.
       1. Bank wysyła komunikat o zablokowaniu karty do bankomatu.
       1. Bankomat otrzymuję informację o zablokowaniu karty.
       2. Bankomat wyświetla komunikat o zablokowanej karcie.
       3. Bankomat wysuwa kartę.
       4. Bankomat powraca do ekranu starowego po upływie 5 sekund.

 8a. Kwota jest wyższa od posiadanych środków.
   1. Bankomat wyświetla informację o wybraniu za dużej kwoty na 3 sekundy.
   2. Ponowne rozpoczęcie kroku 8.
  
 10a. Klient nie chcę drukować potwierdzenia.
   1. Klient nie zgadza się na wydruk potwierdzenia.
   2. pomijamy krok 13.
   3. przechodzimy do kroku 11.

Wymagania specjalne:
--------------------
 - Bankomat musi posiadać opcję przełączenia interfejsu na język Angielski.
 - Domyślny język interfejsu Polski.

Wymagania technologiczne oraz ograniczenia na wprowadzane dane:
---------------------------------------------------------------

 2a. Pin składa się z 4 cyfr.

 3a. Możliwość wysyłania zapytań o weryfikację PIN do banku.

 8a. Możliwość zlecenia bankowi tranzakcji zakupu kodu prepaid.

Kwestie otwarte:
----------------

 - Czy dodajemy jescze jakieś języki obsługujące interfejs.

 - Czy nakładamy limit kwoty doładowania karty prepaidowej.